
> module Tree (Tree(..), Line(..), Def(..), show_tree) where

> import Char

> data Tree = Tree [Either Line Def]
>   deriving Show
> data Line = Line String
>   deriving Show
> data Def = Def Bool Name String
>   deriving Show
> type Name = String

> show_tree :: Tree -> String
> show_tree (Tree xs) = show_tree' xs

> show_tree' :: [Either Line Def] -> String
> show_tree' [] = ""
> show_tree' (Left l:xs) = show_line l ++ show_tree' xs
> show_tree' (Right r:xs) = show_def r ++ show_tree' xs

> show_line :: Line -> String
> show_line (Line s)
>   | take 2 s == "%%"                  = s ++ "\n"
>   | take 2 s == "%!"                  = s ++ "\n"
>   | dropWhile isSpace s == ""         = ""
>   | head (dropWhile isSpace s) == '%' = ""
>   | otherwise                         = s ++ "\n"

> show_def :: Def -> String
> show_def (Def True _ s) = s
> show_def _ = ""

